--- old/usr/src/lib/libproc/common/Plwpregs.c	Wed Apr 12 20:33:23 2023
+++ new/usr/src/lib/libproc/common/Plwpregs.c	Wed Apr 12 20:33:23 2023
@@ -26,6 +26,7 @@
 /*
  * Copyright 2018 Joyent, Inc.
  * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright 2023 Oxide Computer Company
  */
 
 #include <sys/types.h>
@@ -39,9 +40,15 @@
 
 /*
  * This file implements the routines to read and write per-lwp register
- * information from either a live process or core file opened with libproc.
- * We build up a few common routines for reading and writing register
- * information, and then the public functions are all trivial calls to these.
+ * information from either a live process or core file opened with libproc.  We
+ * build up a few common routines for reading and writing register information,
+ * and then the public functions are all trivial calls to these.  It also
+ * implements similar logic that is used with an lwp handle.
+ *
+ * The primary registers and floating point registers (e.g. regs,fpregs) are
+ * retreived from the lwp and process status files.  The library caches the
+ * values of these files.  When we perorm updates, we ensure that cached copies
+ * are refreshed or updated as part of this.
  */
 
 /*
@@ -60,13 +67,14 @@
 			return (lwp);
 	}
 
-	errno = EINVAL;
+	errno = ENOENT;
 	return (NULL);
 }
 
 /*
  * Utility function to open and read the contents of a per-lwp /proc file.
- * This function is used to slurp in lwpstatus, xregs, and asrs.
+ * This function is used to slurp in lwpstatus, lwpname, lwpsinfo, spymaster,
+ * and others.
  */
 static int
 getlwpfile(struct ps_prochandle *P, lwpid_t lwpid,
@@ -83,12 +91,71 @@
 			(void) close(fd);
 			return (0);
 		}
+
+		int e = errno;
 		(void) close(fd);
+		errno = e;
 	}
 	return (-1);
 }
 
 /*
+ * This is a variant of getlwpfile that has three different semantics:
+ *
+ *  o It will stat the file to determine the size and allocate that for the
+ *    caller.
+ *  o If the stat size is zero (e.g. traditional xregs behavior when
+ *    unsupported) then it will return the libproc ENODATA error.
+ *  o It is an error if not all the data is read.
+ *
+ * Currently this is just used by xregs.
+ */
+static int
+getlwpfile_alloc(struct ps_prochandle *P, lwpid_t lwpid, const char *fbase,
+    void **datap, size_t *sizep)
+{
+	char fname[PATH_MAX];
+	int fd;
+
+	(void) snprintf(fname, sizeof (fname), "%s/%d/lwp/%d/%s",
+	    procfs_path, (int)P->status.pr_pid, (int)lwpid, fbase);
+
+	if ((fd = open(fname, O_RDONLY)) >= 0) {
+		int e;
+		struct stat st;
+
+		if (fstat(fd, &st) == 0) {
+			prxregset_t *prx;
+
+			if (st.st_size == 0) {
+				errno = ENODATA;
+				goto clean;
+			}
+
+			prx = malloc(st.st_size);
+			if (prx == NULL) {
+				goto clean;
+			}
+
+			if (read(fd, prx, st.st_size) == st.st_size) {
+				(void) close(fd);
+				*datap = prx;
+				*sizep = st.st_size;
+				return (0);
+			}
+
+			free(prx);
+		}
+clean:
+		e = errno;
+		(void) close(fd);
+		errno = e;
+	}
+
+	return (-1);
+}
+
+/*
  * Get the lwpstatus_t for an lwp from either the live process or our
  * cached information from the core file.  This is used to get the
  * general-purpose registers or floating point registers.
@@ -129,16 +196,49 @@
 }
 
 /*
+ * libproc caches information about the registers for representative LWPs and
+ * threads which we have the thread handle for. When we do a write to certain
+ * files, we need to refresh state and take care of both the process and the
+ * representative LWP's info. Because the xregs may or may not mutate the state
+ * of the other regsiters, we just always do a refresh of the entire cached
+ * psinfo.
+ */
+static void
+refresh_status(struct ps_prochandle *P, lwpid_t lwpid, struct ps_lwphandle *L,
+    long cmd, const void *rp, size_t n)
+{
+	if (P->status.pr_lwp.pr_lwpid == lwpid) {
+		if (cmd == PCSREG)
+			(void) memcpy(P->status.pr_lwp.pr_reg, rp, n);
+		else if (cmd == PCSFPREG)
+			(void) memcpy(&P->status.pr_lwp.pr_fpreg, rp, n);
+		else if (cmd == PCSXREG)
+			(void) Pstopstatus(P, PCNULL, 0);
+	}
+
+	if (L != NULL) {
+		if (cmd == PCSREG)
+			(void) memcpy(&L->lwp_status.pr_reg, rp, n);
+		else if (cmd == PCSFPREG)
+			(void) memcpy(&L->lwp_status.pr_fpreg, rp, n);
+		else if (cmd == PCSXREG)
+			(void) Lstopstatus(L, PCNULL, 0);
+	}
+}
+
+/*
  * Utility function to modify lwp registers.  This is done using either the
- * process control file or per-lwp control file as necessary.
+ * process control file or per-lwp control file as necessary.  This assumes that
+ * we have a process-level hold on things, which may not always be true.
  */
 static int
-setlwpregs(struct ps_prochandle *P, lwpid_t lwpid, long cmd,
+setlwpregs_proc(struct ps_prochandle *P, lwpid_t lwpid, long cmd,
     const void *rp, size_t n)
 {
 	iovec_t iov[2];
 	char fname[PATH_MAX];
-	int fd;
+	struct ps_lwphandle *L;
+	int fd = -1;
 
 	if (P->state != PS_STOP) {
 		errno = EBUSY;
@@ -151,22 +251,32 @@
 	iov[1].iov_len = n;
 
 	/*
+	 * If we have an lwp handle for this thread, then make sure that we use
+	 * that to update the state so cached information is updated.  We sync
+	 * the thread ahead of the process.
+	 */
+	if ((L = Lfind(P, lwpid)) != NULL) {
+		Lsync(L);
+		fd = L->lwp_ctlfd;
+	}
+
+	/*
 	 * Writing the process control file writes the representative lwp.
 	 * Psync before we write to make sure we are consistent with the
 	 * primary interfaces.  Similarly, make sure to update P->status
-	 * afterward if we are modifying one of its register sets.
+	 * afterward if we are modifying one of its register sets.  On some
+	 * platforms the xregs modify the other register states.  As a result,
+	 * always refresh the representative LWP's status.
 	 */
 	if (P->status.pr_lwp.pr_lwpid == lwpid) {
 		Psync(P);
+		fd = P->ctlfd;
+	}
 
-		if (writev(P->ctlfd, iov, 2) == -1)
+	if (fd > -1) {
+		if (writev(fd, iov, 2) == -1)
 			return (-1);
-
-		if (cmd == PCSREG)
-			(void) memcpy(P->status.pr_lwp.pr_reg, rp, n);
-		else if (cmd == PCSFPREG)
-			(void) memcpy(&P->status.pr_lwp.pr_fpreg, rp, n);
-
+		refresh_status(P, lwpid, L, cmd, rp, n);
 		return (0);
 	}
 
@@ -182,11 +292,40 @@
 			(void) close(fd);
 			return (0);
 		}
+		int e = errno;
 		(void) close(fd);
+		errno = e;
 	}
 	return (-1);
 }
 
+/*
+ * This is a variant of the above that only assumes we have a hold on the thread
+ * as opposed to a process.
+ */
+static int
+setlwpregs_lwp(struct ps_lwphandle *L, long cmd, const void *rp, size_t n)
+{
+	iovec_t iov[2];
+
+	if (L->lwp_state != PS_STOP) {
+		errno = EBUSY;
+		return (-1);
+	}
+
+	iov[0].iov_base = (caddr_t)&cmd;
+	iov[0].iov_len = sizeof (long);
+	iov[1].iov_base = (caddr_t)rp;
+	iov[1].iov_len = n;
+
+	Lsync(L);
+	if (writev(L->lwp_ctlfd, iov, 2) == -1)
+		return (-1);
+	refresh_status(L->lwp_proc, L->lwp_id, L, cmd, rp, n);
+
+	return (0);
+}
+
 int
 Plwp_getregs(struct ps_prochandle *P, lwpid_t lwpid, prgregset_t gregs)
 {
@@ -200,12 +339,25 @@
 }
 
 int
+Lgetregs(struct ps_lwphandle *L, prgregset_t *gregs)
+{
+	(void) memcpy(gregs, L->lwp_status.pr_reg, sizeof (prgregset_t));
+	return (0);
+}
+
+int
 Plwp_setregs(struct ps_prochandle *P, lwpid_t lwpid, const prgregset_t gregs)
 {
-	return (setlwpregs(P, lwpid, PCSREG, gregs, sizeof (prgregset_t)));
+	return (setlwpregs_proc(P, lwpid, PCSREG, gregs, sizeof (prgregset_t)));
 }
 
 int
+Lsetregs(struct ps_lwphandle *L, const prgregset_t *gregs)
+{
+	return (setlwpregs_lwp(L, PCSREG, gregs, sizeof (prgregset_t)));
+}
+
+int
 Plwp_getfpregs(struct ps_prochandle *P, lwpid_t lwpid, prfpregset_t *fpregs)
 {
 	lwpstatus_t lps;
@@ -217,16 +369,43 @@
 	return (0);
 }
 
-int Plwp_setfpregs(struct ps_prochandle *P, lwpid_t lwpid,
+int
+Lgetfpregs(struct ps_lwphandle *L, prfpregset_t *fpregs)
+{
+	(void) memcpy(fpregs, &L->lwp_status.pr_fpreg, sizeof (prfpregset_t));
+	return (0);
+}
+
+int
+Plwp_setfpregs(struct ps_prochandle *P, lwpid_t lwpid,
     const prfpregset_t *fpregs)
 {
-	return (setlwpregs(P, lwpid, PCSFPREG, fpregs, sizeof (prfpregset_t)));
+	return (setlwpregs_proc(P, lwpid, PCSFPREG, fpregs,
+	    sizeof (prfpregset_t)));
 }
 
-#if defined(sparc) || defined(__sparc)
 int
-Plwp_getxregs(struct ps_prochandle *P, lwpid_t lwpid, prxregset_t *xregs)
+Lsetfpregs(struct ps_lwphandle *L, const prfpregset_t *fpregs)
 {
+	return (setlwpregs_lwp(L, PCSFPREG, fpregs, sizeof (prfpregset_t)));
+}
+
+/*
+ * The reason that this is structured to take both the size and the process
+ * handle is so that way we have enough information to tie this back to its
+ * underlying source and we can eventually use umem with this.
+ */
+void
+Plwp_freexregs(struct ps_prochandle *P __unused, prxregset_t *prx,
+    size_t size __unused)
+{
+	free(prx);
+}
+
+int
+Plwp_getxregs(struct ps_prochandle *P, lwpid_t lwpid, prxregset_t **xregs,
+    size_t *sizep)
+{
 	lwp_info_t *lwp;
 
 	if (P->state == PS_IDLE) {
@@ -240,12 +419,17 @@
 			return (-1);
 		}
 
-		return (getlwpfile(P, lwpid, "xregs",
-		    xregs, sizeof (prxregset_t)));
+		return (getlwpfile_alloc(P, lwpid, "xregs",
+		    (void **)xregs, sizep));
 	}
 
-	if ((lwp = getlwpcore(P, lwpid)) != NULL && lwp->lwp_xregs != NULL) {
-		(void) memcpy(xregs, lwp->lwp_xregs, sizeof (prxregset_t));
+	if ((lwp = getlwpcore(P, lwpid)) != NULL && lwp->lwp_xregs != NULL &&
+	    lwp->lwp_xregsize > 0) {
+		*xregs = malloc(lwp->lwp_xregsize);
+		if (*xregs == NULL)
+			return (-1);
+		(void) memcpy(*xregs, lwp->lwp_xregs, lwp->lwp_xregsize);
+		*sizep = lwp->lwp_xregsize;
 		return (0);
 	}
 
@@ -255,12 +439,49 @@
 }
 
 int
-Plwp_setxregs(struct ps_prochandle *P, lwpid_t lwpid, const prxregset_t *xregs)
+Lgetxregs(struct ps_lwphandle *L, prxregset_t **xregs, size_t *sizep)
 {
-	return (setlwpregs(P, lwpid, PCSXREG, xregs, sizeof (prxregset_t)));
+	lwp_info_t *lwp;
+
+	if (L->lwp_state != PS_DEAD) {
+		if (L->lwp_state != PS_STOP) {
+			errno = EBUSY;
+			return (-1);
+		}
+		return (getlwpfile_alloc(L->lwp_proc, L->lwp_id, "xregs",
+		    (void **)xregs, sizep));
+	}
+
+	if ((lwp = getlwpcore(L->lwp_proc, L->lwp_id)) != NULL &&
+	    lwp->lwp_xregs != NULL && lwp->lwp_xregsize > 0) {
+		*xregs = malloc(lwp->lwp_xregsize);
+		if (*xregs == NULL)
+			return (-1);
+		(void) memcpy(*xregs, lwp->lwp_xregs, lwp->lwp_xregsize);
+		*sizep = lwp->lwp_xregsize;
+		return (0);
+	}
+
+	if (lwp != NULL)
+		errno = ENODATA;
+	return (-1);
 }
 
 int
+Plwp_setxregs(struct ps_prochandle *P, lwpid_t lwpid, const prxregset_t *xregs,
+    size_t len)
+{
+	return (setlwpregs_proc(P, lwpid, PCSXREG, xregs, len));
+}
+
+int
+Lsetxregs(struct ps_lwphandle *L, const prxregset_t *xregs, size_t len)
+{
+	return (setlwpregs_lwp(L, PCSXREG, xregs, len));
+}
+
+#if defined(sparc) || defined(__sparc)
+int
 Plwp_getgwindows(struct ps_prochandle *P, lwpid_t lwpid, gwindows_t *gwins)
 {
 	lwp_info_t *lwp;
@@ -324,7 +545,7 @@
 int
 Plwp_setasrs(struct ps_prochandle *P, lwpid_t lwpid, const asrset_t asrs)
 {
-	return (setlwpregs(P, lwpid, PCSASRS, asrs, sizeof (asrset_t)));
+	return (setlwpregs_proc(P, lwpid, PCSASRS, asrs, sizeof (asrset_t)));
 }
 #endif	/* __sparcv9 */
 #endif	/* __sparc */
--- old/usr/src/lib/libproc/common/Pservice.c	Wed Apr 12 20:33:23 2023
+++ new/usr/src/lib/libproc/common/Pservice.c	Wed Apr 12 20:33:23 2023
@@ -24,10 +24,12 @@
  */
 /*
  * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright 2023 Oxide Computer Company
  */
 
 #include <stdarg.h>
 #include <string.h>
+#include <errno.h>
 #include "Pcontrol.h"
 
 /*
@@ -167,8 +169,6 @@
 	return (PS_BADLID);
 }
 
-#if defined(sparc) || defined(__sparc)
-
 ps_err_e
 ps_lgetxregsize(struct ps_prochandle *P, lwpid_t lwpid, int *xrsize)
 {
@@ -182,10 +182,16 @@
 		for (lwp = list_head(&core->core_lwp_head); lwp != NULL;
 		    lwp = list_next(&core->core_lwp_head, lwp)) {
 			if (lwp->lwp_id == lwpid) {
-				if (lwp->lwp_xregs != NULL)
-					*xrsize = sizeof (prxregset_t);
-				else
+				if (lwp->lwp_xregs != NULL &&
+				    lwp->lwp_xregsize > 0) {
+					if (lwp->lwp_xregsize >= INT_MAX) {
+						return (PS_ERR);
+					}
+
+					*xrsize = (int)lwp->lwp_xregsize;
+				} else {
 					*xrsize = 0;
+				}
 				return (PS_OK);
 			}
 		}
@@ -199,6 +205,9 @@
 	if (stat(fname, &statb) != 0)
 		return (PS_BADLID);
 
+	if (statb.st_size > INT_MAX)
+		return (PS_ERR);
+
 	*xrsize = (int)statb.st_size;
 	return (PS_OK);
 }
@@ -206,18 +215,56 @@
 ps_err_e
 ps_lgetxregs(struct ps_prochandle *P, lwpid_t lwpid, caddr_t xregs)
 {
+	size_t xregsize;
+	prxregset_t *prx;
+
 	if (P->state != PS_STOP && P->state != PS_DEAD)
 		return (PS_ERR);
 
-	/* LINTED - alignment */
-	if (Plwp_getxregs(P, lwpid, (prxregset_t *)xregs) == 0)
+	if (Plwp_getxregs(P, lwpid, &prx, &xregsize) == 0) {
+		(void) memcpy(xregs, prx, xregsize);
+		Plwp_freexregs(P, prx, xregsize);
 		return (PS_OK);
+	}
 
+	if (errno == ENODATA)
+		return (PS_NOXREGS);
+
 	return (PS_BADLID);
 }
 
 ps_err_e
 ps_lsetxregs(struct ps_prochandle *P, lwpid_t lwpid, caddr_t xregs)
+{
+	size_t xregsize = 0;
+
+	if (P->state != PS_STOP)
+		return (PS_ERR);
+
+	/*
+	 * libproc asks the caller for the size of the extended register set.
+	 * Unfortunately, right now we aren't given the actual size of this
+	 * ourselves and we don't want to break the ABI that folks have used
+	 * historically. Therefore, we reach in and ask the structure in a
+	 * platform-specific way about what this should be. Sorry, this is a bit
+	 * unfortunate. This really shouldn't be a platform-specific #ifdef.
+	 */
+#if defined(__i386) || defined(__amd64)
+	prxregset_hdr_t *hdr = (prxregset_hdr_t *)xregs;
+	xregsize = hdr->pr_size;
+#endif
+	if (xregsize == 0)
+		return (PS_ERR);
+
+	if (Plwp_setxregs(P, lwpid, (prxregset_t *)xregs, xregsize) == 0)
+		return (PS_OK);
+
+	return (PS_BADLID);
+}
+
+#if defined(sparc) || defined(__sparc)
+ps_err_e
+ps_lsetxregs(struct ps_prochandle *P, lwpid_t lwpid, caddr_t xregs)
 {
 	if (P->state != PS_STOP)
 		return (PS_ERR);
--- old/usr/src/lib/libproc/common/libproc.h	Wed Apr 12 20:33:23 2023
+++ new/usr/src/lib/libproc/common/libproc.h	Wed Apr 12 20:33:23 2023
@@ -29,6 +29,7 @@
  * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright 2019, Carlos Neira <cneirabustos@gmail.com>
  * Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
+ * Copyright 2023 Oxide Computer Company
  */
 
 /*
@@ -333,6 +334,13 @@
 extern	int	Lmain_stack(struct ps_lwphandle *, stack_t *);
 extern	int	Lalt_stack(struct ps_lwphandle *, stack_t *);
 
+extern int	Lgetregs(struct ps_lwphandle *, prgregset_t *);
+extern int	Lsetregs(struct ps_lwphandle *, const prgregset_t *);
+extern int	Lgetfpregs(struct ps_lwphandle *, prfpregset_t *);
+extern int	Lsetfpregs(struct ps_lwphandle *, const prfpregset_t *);
+extern int	Lgetxregs(struct ps_lwphandle *, prxregset_t **, size_t *);
+extern int	Lsetxregs(struct ps_lwphandle *, const prxregset_t *, size_t);
+
 /*
  * Function prototypes for system calls forced on the victim process.
  */
@@ -419,11 +427,13 @@
 extern int Plwp_setfpregs(struct ps_prochandle *, lwpid_t,
     const prfpregset_t *);
 
-#if defined(__sparc)
+extern int Plwp_getxregs(struct ps_prochandle *, lwpid_t, prxregset_t **,
+    size_t *);
+extern void Plwp_freexregs(struct ps_prochandle *, prxregset_t *, size_t);
+extern int Plwp_setxregs(struct ps_prochandle *, lwpid_t, const prxregset_t *,
+    size_t);
 
-extern int Plwp_getxregs(struct ps_prochandle *, lwpid_t, prxregset_t *);
-extern int Plwp_setxregs(struct ps_prochandle *, lwpid_t, const prxregset_t *);
-
+#if defined(__sparc)
 extern int Plwp_getgwindows(struct ps_prochandle *, lwpid_t, gwindows_t *);
 
 #if defined(__sparcv9)
--- old/usr/src/lib/libproc/common/mapfile-vers	Wed Apr 12 20:33:24 2023
+++ new/usr/src/lib/libproc/common/mapfile-vers	Wed Apr 12 20:33:24 2023
@@ -25,6 +25,7 @@
 # Copyright (c) 2013 by Delphix. All rights reserved.
 # Copyright (c) 2019 Carlos Neira <cneirabustos@gmail.com>
 # Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
+# Copyright 2023 Oxide Computer Company
 #
 
 #
@@ -76,6 +77,9 @@
 	Ldstop;
 	Lfree;
 	Lgetareg;
+	Lgetfpregs;
+	Lgetregs;
+	Lgetxregs;
 	Lgrab;
 	Lgrab_error;
 	_libproc_debug	{ ASSERT = { TYPE = OBJECT; SIZE = 4; }; };
@@ -83,7 +87,10 @@
 	Lprochandle;
 	Lpsinfo;
 	Lputareg;
+	Lsetfpregs;
+	Lsetregs;
 	Lsetrun;
+	Lsetxregs;
 	Lstack;
 	Lstate;
 	Lstatus;
@@ -137,16 +144,19 @@
 	Plookup_by_addr;
 	Plookup_by_name;
 	Plwp_alt_stack;
+	Plwp_freexregs;
 	Plwp_getfpregs;
 	Plwp_getname;
 	Plwp_getpsinfo;
 	Plwp_getregs;
 	Plwp_getspymaster;
+	Plwp_getxregs;
 	Plwp_iter;
 	Plwp_iter_all;
 	Plwp_main_stack;
 	Plwp_setfpregs;
 	Plwp_setregs;
+	Plwp_setxregs;
 	Plwp_stack;
 	Pmapping_iter;
 	Pmapping_iter_resolved;
@@ -272,8 +282,11 @@
 	ps_lcontinue;
 	ps_lgetfpregs;
 	ps_lgetregs;
+	ps_lgetxregs;
+	ps_lgetxregsize;
 	ps_lsetfpregs;
 	ps_lsetregs;
+	ps_lsetxregs;
 	ps_lstop;
 	ps_pauxv;
 	ps_pbrandname;
@@ -332,12 +345,6 @@
 
 $if _sparc
 	Plwp_getgwindows;
-	Plwp_getxregs;
-	Plwp_setxregs;
-	ps_lgetxregs;
-	ps_lgetxregsize;
-	ps_lsetxregs;
-
 $if _ELF64
 	Plwp_getasrs;
 	Plwp_setasrs;
--- old/usr/src/man/man2/Makefile	Wed Apr 12 20:33:24 2023
+++ new/usr/src/man/man2/Makefile	Wed Apr 12 20:33:24 2023
@@ -202,6 +202,7 @@
 		futimesat.2			\
 		futimens.2			\
 		getaudit_addr.2			\
+		getcontext_extd.2		\
 		getegid.2			\
 		geteuid.2			\
 		getgid.2			\
@@ -320,6 +321,7 @@
 
 setauid.2			:= LINKSRC = getauid.2
 
+getcontext_extd.2		:= LINKSRC = getcontext.2
 setcontext.2			:= LINKSRC = getcontext.2
 
 setgroups.2			:= LINKSRC = getgroups.2
--- old/usr/src/man/man3c/Makefile	Wed Apr 12 20:33:24 2023
+++ new/usr/src/man/man3c/Makefile	Wed Apr 12 20:33:24 2023
@@ -528,6 +528,7 @@
 		u8_validate.3c					\
 		ualarm.3c					\
 		uconv_u16tou32.3c				\
+		ucontext_alloc.3c				\
 		ucred.3c					\
 		ungetc.3c					\
 		ungetwc.3c					\
@@ -1305,6 +1306,7 @@
 		strtoumax.3c				\
 		strxfrm_l.3c				\
 		swapcontext.3c				\
+		swapcontext_extd.3c			\
 		swprintf.3c				\
 		swscanf.3c				\
 		tdelete.3c				\
@@ -1347,6 +1349,7 @@
 		uconv_u32tou8.3c			\
 		uconv_u8tou16.3c			\
 		uconv_u8tou32.3c			\
+		ucontext_free.3c			\
 		ucred_free.3c				\
 		ucred_get.3c				\
 		ucred_getegid.3c			\
@@ -2019,6 +2022,7 @@
 lfind.3c				:= LINKSRC = lsearch.3c
 
 swapcontext.3c				:= LINKSRC = makecontext.3c
+swapcontext_extd.3c			:= LINKSRC = makecontext.3c
 
 major.3c				:= LINKSRC = makedev.3c
 minor.3c				:= LINKSRC = makedev.3c
@@ -2499,6 +2503,8 @@
 
 ttyname_r.3c				:= LINKSRC = ttyname.3c
 
+ucontext_free.3c			:= LINKSRC = ucontext_alloc.3c
+
 uconv_u16tou8.3c			:= LINKSRC = uconv_u16tou32.3c
 uconv_u32tou16.3c			:= LINKSRC = uconv_u16tou32.3c
 uconv_u32tou8.3c			:= LINKSRC = uconv_u16tou32.3c
--- old/usr/src/man/man3c/makecontext.3c	Wed Apr 12 20:33:24 2023
+++ new/usr/src/man/man3c/makecontext.3c	Wed Apr 12 20:33:24 2023
@@ -43,86 +43,144 @@
 .\" Copyright 1989 AT&T
 .\" Portions Copyright (c) 1992, X/Open Company Limited.  All Rights Reserved.
 .\" Copyright (c) 2004, Sun Microsystems, Inc.  All Rights Reserved.
+.\" Copyright 2023 Oxide Computer Company
 .\"
-.TH MAKECONTEXT 3C "February 17, 2023"
-.SH NAME
-makecontext, swapcontext \- manipulate user contexts
-.SH SYNOPSIS
-.nf
-#include <ucontext.h>
-
-\fBvoid\fR \fBmakecontext\fR(\fBucontext_t *\fR\fIucp\fR, \fBvoid (*\fR\fIfunc\fR)(), \fBint\fR \fIargc\fR...);
-.fi
-
-.LP
-.nf
-\fBint\fR \fBswapcontext\fR(\fBucontext_t *restrict\fR \fIoucp\fR,
-     \fBconst ucontext_t *restrict\fR \fIucp\fR);
-.fi
-
-.SH DESCRIPTION
-The \fBmakecontext()\fR function modifies the context specified by \fIucp\fR,
-which has been initialized using \fBgetcontext\fR(2). When this context is
-resumed using \fBswapcontext()\fR or \fBsetcontext\fR(2), execution continues
-by calling the function \fIfunc\fR, passing it the arguments that follow
-\fIargc\fR in the \fBmakecontext()\fR call. The value of \fIargc\fR must match
-the number of pointer-sized integer arguments passed to \fIfunc\fR, otherwise
-the behavior is undefined.
-.sp
-.LP
-Before a call is made to \fBmakecontext()\fR, the context being modified should
-have a stack allocated for it. The stack is assigned to the context by
-initializing the \fBuc_stack\fR member.
-.sp
-.LP
-The \fBuc_link\fR member is used to determine the context that will be resumed
-when the context being modified by \fBmakecontext()\fR returns.  The
-\fBuc_link\fR member should be initialized prior to the call to
-\fBmakecontext()\fR. If the \fBuc_link\fR member is initialized to \fINULL\fR,
-the thread executing \fIfunc\fR will exit when \fIfunc\fR returns. See
-\fBpthread_exit\fR(3C).
-.sp
-.LP
-The \fBswapcontext()\fR function saves the current context in the context
-structure pointed to by \fIoucp\fR and sets the context to the context
-structure pointed to by \fIucp\fR.
-.sp
-.LP
-If the \fIucp\fR or \fIoucp\fR argument points to an invalid address, the
-behavior is undefined and \fBerrno\fR may be set to \fBEFAULT\fR.
-.SH RETURN VALUES
-On successful completion, \fBswapcontext()\fR returns \fB0\fR. Otherwise,
-\fB\(mi1\fR is returned and \fBerrno\fR is set to indicate the error.
-.SH ERRORS
-The \fBswapcontext()\fR function will fail if:
-.sp
-.ne 2
-.na
-\fB\fBENOMEM\fR\fR
-.ad
-.RS 10n
-The \fIucp\fR argument does not have enough stack left to complete the
-operation.
-.RE
-
-.sp
-.LP
-The \fBswapcontext()\fR function may fail if:
-.sp
-.ne 2
-.na
-\fB\fBEFAULT\fR\fR
-.ad
-.RS 10n
-The \fIucp\fR or \fIoucp\fR argument points to an invalid address.
-.RE
-
-.SH EXAMPLES
-\fBExample 1 \fRAlternate execution context on a stack whose memory was
-allocated using \fBmmap()\fR.
-.sp
-.in +2
-.nf
+.Dd March 20, 2023
+.Dt MAKECONTEXT 3C
+.Os
+.Sh NAME
+.Nm makecontext ,
+.Nm swapcontext ,
+.Nm swapcontext_extd
+.Nd manipulate user contexts
+.Sh SYNOPSIS
+.In ucontext.h
+.Ft void
+.Fo makecontext
+.Fa "ucontext_t *ucp"
+.Fa "void (*ifunc)()"
+.Fa "int argc"
+.Fa "..."
+.Fc
+.Ft int
+.Fo swapcontext
+.Fa "ucontext_t *restrict oucp"
+.Fa "const ucontext_t *restrict ucp"
+.Fc
+.Ft int
+.Fo swapcontext_extd
+.Fa "ucontext_t *restrict oucp"
+.Fa "uint32_t flags"
+.Fa "const ucontext_t *restrict ucp"
+.Fc
+.Sh DESCRIPTION
+The
+.Fn makecontext
+function modifies the context specified by
+.Fa ucp ,
+which has been initialized using
+.Xr getcontext 2 or
+.Xr getcontext_extd 2 .
+When this context is resumed using
+.Fn swapcontext ,
+.Fn swapcontext_extd ,
+or
+.Xr setcontext 2 ,
+execution continues by calling the function
+.Fa func ,
+passing it the arguments that follow
+.Fa argc
+in the
+.Fn makecontext
+call.
+The value of
+.Fa argc
+must match the number of pointer-sized integer arguments passed to
+.Fa func ,
+otherwise the behavior is undefined.
+.Pp
+Before a call is made to
+.Fn makecontext ,
+the context being modified should have a stack allocated for it.
+The stack is assigned to the context by initializing the
+.Fa uc_stack
+member.
+.Pp
+The
+.Fa uc_link
+member is used to determine the context that will be resumed when the context
+being modified by
+.Fn makecontext
+returns.
+The
+.Fa uc_link
+member should be initialized prior to the call to
+.Fn makecontext .
+If the
+.Fa uc_link
+member is initialized to
+.Dv NULL ,
+the thread executing
+.Fa func
+will exit when
+.Fa func returns.
+See
+.Xr pthread_exit 3C .
+.Pp
+The
+.Fn swapcontext
+function saves the current context in the context structure pointed to by
+.Fa oucp
+and sets the context to the context structure pointed to by
+.Fa ucp .
+.Pp
+If the
+.Fa ucp
+or
+.Fa oucp
+argument points to an invalid address, the behavior is undefined and
+.Va errno
+may be set to
+.Er EFAULT .
+.Pp
+The
+.Fn swapcontext_extd
+function is similar to
+.Fn swapcontext
+except that it performs a call to
+.Xr getcontext_extd 2
+to get and save the current context, passing the
+.Fa flags
+argument to
+.Xr getcontext_extd 2 .
+Note, the same constraints around the initialization of the
+.Vt ucontext_t
+that are discussed in
+.Xr getcontext_extd 2
+still apply.
+Mainly, the context must either have originally come from
+.Xr ucontext_alloc 3C
+or prior to its first use been zeroed.
+See
+.Xr getcontext_extd 2
+for more information.
+.Sh RETURN VALUES
+On successful completion,
+.Fn swapcontext
+and
+.Fn swapcontext_extd
+return
+.Sy 0 .
+Otherwise,
+.Sy -1
+is returned and
+.Va errno
+is set to indicate the error.
+.Sh EXAMPLES
+.Sy Example 1
+Alternate execution context on a stack whose memory was allocated using
+.Fn mmap .
+.Bd -literal -offset 2
 #include <stdio.h>
 #include <ucontext.h>
 #include <sys/mman.h>
@@ -157,61 +215,95 @@
 
         return (0);
 }
-.fi
-.in -2
-
-.SH USAGE
+.Ed
+.Sh ERRORS
+The
+.Fn swapcontext
+and
+.Fn swapcontext_extd
+function will fail if:
+.Bl -tag -width Er
+.It Er ENOMEM
+The
+.Fa ucp
+argument does not have enough stack left to complete the operation.
+.El
+.Pp
+The
+.Fn swapcontext
+and
+.Fn swapcontext_extd
+functions may fail if:
+.Bl -tag -width Er
+.It Er EFAULT
+The
+.Fa ucp
+or
+.Fa oucp
+argument points to an invalid address.
+.El
+.Pp
+The
+.Fn swapcontext_extd
+function may additionally fail if:
+.Bl -tag -width Er
+.It Er EINVAL
+The
+.Fa flags
+argument contains invalid values.
+.El
+.Sh USAGE
 These functions are useful for implementing user-level context switching
-between multiple threads of control within a process (co-processing). More
-effective multiple threads of control can be obtained by using native support
-for multithreading. See \fBthreads\fR(7).
-.SH ATTRIBUTES
-See \fBattributes\fR(7) for descriptions of the following attributes:
-.sp
-
-.sp
-.TS
-box;
-c | c
-l | l .
-ATTRIBUTE TYPE	ATTRIBUTE VALUE
-_
-Interface Stability	Standard
-_
-MT-Level	MT-Safe
-.TE
-
-.SH SEE ALSO
-.BR getcontext (2),
-.BR mmap (2),
-.BR sigaction (2),
-.BR sigprocmask (2),
-.BR pthread_exit (3C),
-.BR ucontext.h (3HEAD),
-.BR attributes (7),
-.BR standards (7),
-.BR threads (7)
-.SH NOTES
-The semantics of the \fBuc_stack\fR member of the \fBucontext_t\fR structure
-have changed as they apply to inputs to \fBmakecontext()\fR. Prior to Solaris
-10, the \fBss_sp\fR member of the \fBuc_stack\fR structure represented the high
-memory address of the area reserved for the stack. The \fBss_sp\fR member now
-represents the base (low memory address), in keeping with other uses of
-\fBss_sp\fR.
-.sp
-.LP
-This change in the meaning of \fBss_sp\fR is now the default behavior. The
-\fB-D__MAKECONTEXT_V2_SOURCE\fR compilation flag used in Solaris 9 update
-releases to access this behavior is obsolete.
-.sp
-.LP
+between multiple threads of control within a process
+.Pq co-processing .
+More effective multiple threads of control can be obtained by using native
+support for multithreading.
+See
+.Xr threads 7 .
+.Sh INTERFACE STABILITY
+.Sy Committed
+.Sh MT-LEVEL
+.Sy MT-Safe
+.Sh SEE ALSO
+.Xr getcontext 2 ,
+.Xr getcontext_extd 2 ,
+.Xr mmap 2 ,
+.Xr sigaction 2 ,
+.Xr sigprocmask 2 ,
+.Xr pthread_exit 3C ,
+.Xr ucontext_alloc 3C ,
+.Xr ucontext.h 3HEAD ,
+.Xr attributes 7 ,
+.Xr standards 7 ,
+.Xr threads 7
+.Sh NOTES
+The semantics of the
+.Fa uc_stack
+member of the
+.Fa ucontext_t
+structure have changed as they apply to inputs to
+.Fn makecontext .
+Prior to Solaris 10, the
+.Fa ss_sp
+member of the
+.Fa uc_stack
+tructure represented the high memory address of the area reserved for the stack.
+The
+.Fa ss_sp
+member now represents the base
+.Pq low memory address ,
+in keeping with other uses of
+.Fa ss_sp .
+This change in the meaning of
+.Fa ss_sp
+is the default behavior.
+.Pp
 Binary compatibility has been preserved with releases prior to Solaris 10.
-Before recompiling, applications that use \fBmakecontext()\fR must be updated
-to reflect this behavior change. The example below demonstrates a typical change
-that must be applied:
-.sp
-.in +2
-.nf
+Before recompiling, applications that use
+.Fn makecontext
+must be updated to reflect this behavior change.
+The example below demonstrates a typical change that must be applied:
+.Bd -literal -offset 2
 --- example1_s9.c       Thu Oct  3 11:58:17 2002
 +++ example1.c  Thu Jun 27 13:28:16 2002
 @@ -27,12 +27,9 @@
@@ -226,5 +318,4 @@
 
         makecontext(&uc, assign, 2, 100L, &value);
 .fi
-.in -2
-
+.Ed
--- /dev/null	Wed Apr 12 20:33:24 2023
+++ new/usr/src/man/man3c/ucontext_alloc.3c	Wed Apr 12 20:33:24 2023
@@ -0,0 +1,129 @@
+.\"
+.\" This file and its contents are supplied under the terms of the
+.\" Common Development and Distribution License ("CDDL"), version 1.0.
+.\" You may only use this file in accordance with the terms of version
+.\" 1.0 of the CDDL.
+.\"
+.\" A full copy of the text of the CDDL should have accompanied this
+.\" source.  A copy of the CDDL is also available via the Internet at
+.\" http://www.illumos.org/license/CDDL.
+.\"
+.\"
+.\" Copyright 2023 Oxide Computer Company
+.\"
+.Dd January 24, 2023
+.Dt UCONTEXT_ALLOC 3C
+.Os
+.Sh NAME
+.Nm ucontext_alloc ,
+.Nm ucontext_free
+.Nd allocate and free ucontext structures
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In ucontext.h
+.Ft "ucontext_t *"
+.Fo ucontext_alloc
+.Fa "uint32_t flags"
+.Fc
+.Ft void
+.Fo ucontext_free
+.Fa "ucontext_t *ucp"
+.Fc
+.Sh DESCRIPTION
+The
+.Fn ucontext_alloc
+function allocates and initializes a
+.Vt ucontext_t
+structure for subsequent use with
+.Xr getcontext_extd 2
+or
+.Xr swapcontext_extd 2 .
+.Pp
+Traditionally applications declare the
+.Vt ucontext_t
+structure on the stack, as part of another structure, or in other global data.
+Due to the advent of extended states
+.Pq such as the x86 xsave state
+the traditional structure is not sufficient to capture all state.
+The
+.Fn ucontext_alloc
+function determines the correct size for the current process to cover all of its
+extended states in addition to the standard
+.Vt ucontext_t
+and then proceeds to set up the other members of the
+.Vt ucontext_t
+to point at the additional memory.
+.Pp
+It is not recommended that the returned
+.Vt ucontext
+structure can be used with either
+.Xr getcontext 2
+or
+.Xr swapcontext 2 .
+While the resulting calls will work, they will not preserve that space for the
+extended state has been allocated.
+No memory will be leaked as a result of that.
+.Pp
+The
+.Fn ucontext_free
+function is used to release all the memory associated with
+.Fa ucp .
+.Fa ucp
+must have come from a prior call to
+.Fn ucontext_alloc .
+If it is not, then it is undefined as to what will happen to the program, but it
+will result in eventual memory corruption.
+If
+.Fa ucp
+was declared on the stack, as a structure member, as global data, or allocated
+in some way that wasn't calling
+.Fn ucontext_alloc ,
+do not pass it to
+.Fn ucontext_free .
+.Sh RETURN VALUES
+Upon successful completion, the
+.Fn ucontext_alloc
+function returns a pointer to an allocated
+.Vt ucontext_t .
+Otherwise
+.Dv NULL
+is returned and
+.Va errno
+is set to indicate the error.
+.Sh ERRORS
+The
+.Fn ucontext_alloc
+function will set
+.Va errno
+based on the failure of the underlying memory allocator.
+For more information and details on these errors, see
+.Xr malloc 3C ,
+the list of errors below may not be exhaustive.
+.Pp
+The
+.Fn ucontext_alloc
+function will fail if:
+.Bl -tag -width Er
+.It Er EINVAL
+The
+.Fa flags
+argument had unknown or unsupported values.
+.It Er ENOMEM
+There was insufficient memory to allocate an extended ucontext
+structure.
+See
+.Xr malloc 3C
+for more information.
+.It Er EAGAIN
+There was insufficient memory to allocate an extended ucontext
+structure, but the application could try again later.
+See
+.Xr malloc 3C
+for more information.
+.El
+.Sh INTERFACE STABILITY
+.Sy Committed
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
